"""
    ManagerServer.py
    
    Desc: this class provides an XML-RPC server to listen to remote calls
        from a client. WHen the startServer(Manager, port) fcn. at the bottom 
         is called from Manager, a Manager instance is registered and
          the XML-RPC server is activated. 
"""
from SimpleXMLRPCServer import SimpleXMLRPCServer
import sys, time #, sched
import threading

class ManagerServer:
    
    def __init__(self, Manager):
        """
            Input: an instance of Manager
        """
        self.myManager = Manager
        #self.myScheduler = sched.scheduler(time.time, time.sleep)
        self.lock = threading.Lock()
        
    def fixityTest(self):
        self.lock.acquire()
        self.myManager.fixityTest()
        self.myManager.forceLogDump()
        self.lock.release()
        return 1
    
    def runSchedule(self):
        self.myManager.runSchedule()
        return 1
    
    def addFile(self, someFile):
        self.lock.acquire()
        self.myManager.addFile(someFile)
        self.lock.release()
        return 1

    def removeFile(self, someFile):
        self.lock.acquire()
        self.myManager.removeFile(someFile)
        self.lock.release()
        return 1
    
    def forceLogDump(self):
        self.myManager.forceLogDump()
        return 1

def startServer(Manager, port):
    
    server = SimpleXMLRPCServer(("35.9.22.158", port))
    server.register_introspection_functions()
    print 'Kora Event Logging Server On....'
    server.register_instance(ManagerServer(Manager))
    server.serve_forever()


