# a test script,USAGE: ManagerTest.py <port number> defaults to port 8000
"""
    This script tests the Event Logging System using an XML-RPC connection.
    The file does the following things:
        1) attempt to add 2 files which don't exist
        2) run a fixity test to init. the dbase if it isn't already
        3) corrupt the local dbase and test for Error logging
        4) restore the local dbase and test for correctness
        5) remove a file

"""

import xmlrpclib
import sys, sqlite3, os

# TEST THE SERVER
port = 8000
for arg in sys.argv[1:]:
    port = int(arg)

#server = xmlrpclib.Server('http://localhost:%d' % port)
server = xmlrpclib.Server('http://35.9.22.158:%d' % port)
print 'Running tests...'

# TEST 'FAILED TO OPEN' events
server.addFile('testtesttest.txt')
server.addFile('hellolll.txt')

# TEST 'ADDED' events & init. dbase if not already...
server.fixityTest()

# TEST 'ERROR' events by scrambling checksums
conn = sqlite3.connect(os.getcwd()+'/dbase/managerdb')
cursor = conn.cursor()
cursor.execute("SELECT pkey FROM checksums LIMIT 1000")
rows = cursor.fetchall()
correctChecksums = {} # save old, correct checksums here...
for row in rows:
    cursor.execute("SELECT checksum FROM checksums WHERE pkey='%s'" % row[0])
    result = cursor.fetchone()
    correctChecksums[row[0]] = result[0]
    cursor.execute("UPDATE checksums SET checksum='WRONG!!!' WHERE pkey='%s'" % row[0])
    conn.commit()
#end
server.fixityTest()

# RESTORE checksums and test again
cursor.execute("SELECT pkey FROM checksums LIMIT 1000")
rows = cursor.fetchall()
for row in rows:
    checksum = correctChecksums[row[0]]
    cursor.execute("UPDATE checksums SET checksum='%s' WHERE pkey='%s'" % (checksum, row[0]))
    conn.commit()
#end
server.fixityTest()
# TEST 'REMOVE' event
server.removeFile('447.txt')
server.forceLogDump()

#cursor.execute("DROP TABLE checksums")
#conn.commit()

print 'Done'

