#checksum time test, checksum vs network drive time
# 
"""
benchmarks by algorithm,  using local access
# files           10       20       40          80         160   
amt of data      266MB    350MB     456MB       1.016GB     2.388GB
 sha512           8        11          20         41          105     
 sha384           6         9          20         51          103
 sha256           9        13          25         64          116
 sha224           9        11          25         52          124  
 sha1             2         5           7         26           71 
 md5              2         4           6         24           68 
 
 Network Access using sha512
 
 amt of data 253MB    321MB   519MB    1.046GB     1.93GB
 Network      5       9         26      52            92
 
 ...times in seconds
 
 fixityTests using Manager.py using md5 on 13GB of data
 30MB/s server bandwidth (50MB max), 10MB/s desktop (20MB max)
 # workers/machine    1      2      

        1            8.55   15.9     (1 server)
        2           11.45   24.3     (2 server)   
        3           14.45   32.3     (2 server + 1 desktop)
        4           15.35   33.6     (2 server + 2 desktop)
 
 ...times in minutes
 
 FILE OPEN VS TEST NETWORK
 Amt. Data  Open    Test
 1046       100s    18s
 1930       185s    33s
 2593       249s    43s
 3193       306s    56s
 
 FILE OPEN VS TEST LOCAL ACCESS
 Amt. Data  Open    Test
 1077       37s     22s
 2046       70s     43s
 2720       93s     56s
 3462      133s     90s
 
 # WORKERS ON 1 MACHINE LOCAL ACCESS
 1      8.76minutes
 2     22.98minutes
 3      
 4
 
 
"""
import hashlib
import os
import time

def job(): # using file obj iter.
    size = 0
    files = os.listdir('/home/administrator/Desktop/matrixLocal/')
    m = hashlib.sha512()
    testTime = 0.0
    openTime = 0.0
    for filename in files[:40]:
        start = time.time()
        data = open('/home/administrator/Desktop/matrixLocal/'+filename)
        data = data.readlines()
        end = time.time()
        openTime += abs(start-end)
       
        size += os.path.getsize('/home/administrator/Desktop/matrixLocal/'+filename)
        
        start = time.time()
        for line in data:
            m.update(line)
        end = time.time()
        testTime += abs(end-start)
        
        m.digest()
    print 'Open time: ', int(openTime)
    print 'Test time: ', int(testTime)
    return size

"""
def job2():
    files = os.listdir('/home/administrator/Desktop/matrix/')
    m = hashlib.sha512()
    for filename in files[:20]:
        data = open('/home/administrator/Desktop/matrix/'+filename)
        temp = data.read()
        m.update(temp)
        m.digest()
"""
#profile.run('print job()')
print job()

#profile.run('job2()')


        
        